/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#ifndef _TRIOS_NNTI_XDR_H_RPCGEN
#define _TRIOS_NNTI_XDR_H_RPCGEN

#include <Trios_nnti_xdr.h>


#ifdef __cplusplus
extern "C" {
#endif

#include "Trios_xdr.h"
#include <stdint.h>

typedef uint64_t NNTI_size;

typedef uint64_t NNTI_ssize;
#define NNTI_HOSTNAME_LEN 32
#define NNTI_URL_LEN 128
#define NNTI_REQUEST_BUFFER_SIZE 1216
#define NNTI_RESULT_BUFFER_SIZE 1216

enum NNTI_datatype_t {
	NNTI_dt_transport = 1111,
	NNTI_dt_peer = 1112,
	NNTI_dt_buffer = 1113,
	NNTI_dt_work_request = 1114,
	NNTI_dt_status = 1115
};
typedef enum NNTI_datatype_t NNTI_datatype_t;

enum NNTI_transport_id_t {
	NNTI_TRANSPORT_NULL = 0,
	NNTI_TRANSPORT_PORTALS = 1,
	NNTI_TRANSPORT_IB = 2,
	NNTI_TRANSPORT_GEMINI = 3,
	NNTI_TRANSPORT_DCMF = 4,
	NNTI_TRANSPORT_PAMI = 5,
	NNTI_TRANSPORT_MPI = 6,
	NNTI_TRANSPORT_LOCAL = 7
};
typedef enum NNTI_transport_id_t NNTI_transport_id_t;
#define NNTI_TRANSPORT_COUNT 8

enum NNTI_result_t {
	NNTI_OK = 0,
	NNTI_EIO = 1001,
	NNTI_EMSGSIZE = 1001 + 1,
	NNTI_ECANCELED = 1001 + 2,
	NNTI_ETIMEDOUT = 1001 + 3,
	NNTI_EINVAL = 1001 + 4,
	NNTI_ENOMEM = 1001 + 5,
	NNTI_ENOENT = 1001 + 6,
	NNTI_ENOTSUP = 1001 + 7,
	NNTI_EEXIST = 1001 + 8,
	NNTI_EBADRPC = 1001 + 9,
	NNTI_ENOTINIT = 1001 + 10,
	NNTI_EPERM = 1001 + 11,
	NNTI_EINTR = 1001 + 12,
	NNTI_EWOULDBLOCK = 1001 + 13,
	NNTI_EAGAIN = 1001 + 14,
	NNTI_EDROPPED = 1001 + 15,
	NNTI_EDECODE = 1001 + 16,
	NNTI_EENCODE = 1001 + 17
};
typedef enum NNTI_result_t NNTI_result_t;

enum NNTI_atomic_op_t {
	NNTI_ATOMIC_FADD = 0
};
typedef enum NNTI_atomic_op_t NNTI_atomic_op_t;

typedef uint32_t NNTI_ip_addr;

typedef uint16_t NNTI_tcp_port;

struct NNTI_null_process_t {
	int i;
};
typedef struct NNTI_null_process_t NNTI_null_process_t;

typedef uint32_t NNTI_nid;

typedef uint32_t NNTI_pid;

struct NNTI_portals_process_t {
	NNTI_nid nid;
	NNTI_pid pid;
};
typedef struct NNTI_portals_process_t NNTI_portals_process_t;

typedef uint32_t NNTI_qp_num;

struct NNTI_ib_process_t {
	NNTI_ip_addr addr;
	NNTI_tcp_port port;
	NNTI_qp_num qpn;
};
typedef struct NNTI_ib_process_t NNTI_ib_process_t;

typedef uint32_t NNTI_instance_id;

struct NNTI_gni_process_t {
	NNTI_ip_addr addr;
	NNTI_tcp_port port;
	NNTI_instance_id inst_id;
};
typedef struct NNTI_gni_process_t NNTI_gni_process_t;

struct NNTI_bgpdcmf_process_t {
	int xcoord;
	int ycoord;
	int zcoord;
	int pset_rank;
};
typedef struct NNTI_bgpdcmf_process_t NNTI_bgpdcmf_process_t;

struct NNTI_bgqpami_process_t {
	int pset_rank;
	int taskid;
	int thrid;
};
typedef struct NNTI_bgqpami_process_t NNTI_bgqpami_process_t;

struct NNTI_mpi_process_t {
	int rank;
};
typedef struct NNTI_mpi_process_t NNTI_mpi_process_t;

struct NNTI_local_process_t {
	int i;
};
typedef struct NNTI_local_process_t NNTI_local_process_t;

struct NNTI_remote_process_t {
	NNTI_transport_id_t transport_id;
	union {
		NNTI_null_process_t null;
		NNTI_portals_process_t portals;
		NNTI_ib_process_t ib;
		NNTI_gni_process_t gni;
		NNTI_bgpdcmf_process_t bgpdcmf;
		NNTI_bgqpami_process_t bgqpami;
		NNTI_mpi_process_t mpi;
		NNTI_local_process_t local;
	} NNTI_remote_process_t_u;
};
typedef struct NNTI_remote_process_t NNTI_remote_process_t;

struct NNTI_peer_t {
	NNTI_datatype_t datatype;
	char url[NNTI_URL_LEN];
	NNTI_remote_process_t peer;
};
typedef struct NNTI_peer_t NNTI_peer_t;

struct NNTI_null_rdma_addr_t {
	int i;
};
typedef struct NNTI_null_rdma_addr_t NNTI_null_rdma_addr_t;

typedef uint64_t NNTI_match_bits;

enum NNTI_portals_indices {
	NNTI_REQ_PT_INDEX = 1,
	NNTI_RECV_PT_INDEX = 1 + 1,
	NNTI_DATA_PT_INDEX = 1 + 2,
	NNTI_LONG_ARGS_PT_INDEX = 1 + 3,
	NNTI_LONG_RES_PT_INDEX = 1 + 4
};
typedef enum NNTI_portals_indices NNTI_portals_indices;

struct NNTI_portals_rdma_addr_t {
	NNTI_portals_indices buffer_id;
	NNTI_match_bits match_bits;
	uint32_t size;
};
typedef struct NNTI_portals_rdma_addr_t NNTI_portals_rdma_addr_t;

struct NNTI_ib_rdma_addr_t {
	uint64_t buf;
	uint32_t key;
	uint32_t size;
	uint64_t ack_buf;
	uint32_t ack_key;
	uint32_t ack_size;
};
typedef struct NNTI_ib_rdma_addr_t NNTI_ib_rdma_addr_t;

enum NNTI_gni_buffer_type_t {
	NNTI_GNI_RDMA_INITIATOR = 0,
	NNTI_GNI_RDMA_TARGET = 1,
	NNTI_GNI_SEND_SRC = 2,
	NNTI_GNI_REQUEST_BUFFER = 3
};
typedef enum NNTI_gni_buffer_type_t NNTI_gni_buffer_type_t;

struct NNTI_gni_mem_hdl_t {
	uint64_t qword1;
	uint64_t qword2;
};
typedef struct NNTI_gni_mem_hdl_t NNTI_gni_mem_hdl_t;

struct NNTI_gni_rdma_addr_t {
	uint64_t buf;
	uint32_t size;
	NNTI_gni_mem_hdl_t mem_hdl;
	uint64_t wc_addr;
	NNTI_gni_mem_hdl_t wc_mem_hdl;
	NNTI_gni_buffer_type_t type;
};
typedef struct NNTI_gni_rdma_addr_t NNTI_gni_rdma_addr_t;

struct NNTI_bgpdcmf_memreg_hdl_t {
	u_int word0;
	u_int word1;
	u_int word2;
	u_int word3;
};
typedef struct NNTI_bgpdcmf_memreg_hdl_t NNTI_bgpdcmf_memreg_hdl_t;

enum NNTI_bgpdcmf_buffer_type_t {
	NNTI_DCMF_REQUEST_BUFFER = 0,
	NNTI_DCMF_RESULT_BUFFER = 1,
	NNTI_DCMF_SEND_SRC = 2,
	NNTI_DCMF_RECEIVE_DST = 3
};
typedef enum NNTI_bgpdcmf_buffer_type_t NNTI_bgpdcmf_buffer_type_t;

struct NNTI_bgpdcmf_rdma_addr_t {
	uint64_t buf;
	uint32_t size;
	uint32_t owner_rank;
	NNTI_bgpdcmf_buffer_type_t type;
	NNTI_bgpdcmf_memreg_hdl_t mem_hdl;
	uint64_t wc_addr;
	NNTI_bgpdcmf_memreg_hdl_t wc_mem_hdl;
};
typedef struct NNTI_bgpdcmf_rdma_addr_t NNTI_bgpdcmf_rdma_addr_t;

enum NNTI_bgqpami_buffer_type_t {
	NNTI_PAMI_REQUEST_BUFFER = 0,
	NNTI_PAMI_RESULT_BUFFER = 1,
	NNTI_PAMI_SEND_SRC = 2,
	NNTI_PAMI_RECEIVE_DST = 3
};
typedef enum NNTI_bgqpami_buffer_type_t NNTI_bgqpami_buffer_type_t;

struct NNTI_bgqpami_rdma_addr_t {
	uint64_t buf;
	uint32_t size;
	uint32_t owner_rank;
	NNTI_bgqpami_buffer_type_t type;
	uint64_t mem_hdl;
	uint64_t wc_addr;
	uint64_t wc_mem_hdl;
};
typedef struct NNTI_bgqpami_rdma_addr_t NNTI_bgqpami_rdma_addr_t;

struct NNTI_mpi_rdma_addr_t {
	NNTI_match_bits rtr_tag;
	NNTI_match_bits rts_tag;
	NNTI_match_bits data_tag;
	uint32_t size;
};
typedef struct NNTI_mpi_rdma_addr_t NNTI_mpi_rdma_addr_t;

struct NNTI_local_rdma_addr_t {
	int i;
};
typedef struct NNTI_local_rdma_addr_t NNTI_local_rdma_addr_t;

struct NNTI_remote_addr_t {
	NNTI_transport_id_t transport_id;
	union {
		NNTI_null_rdma_addr_t null;
		NNTI_portals_rdma_addr_t portals;
		NNTI_ib_rdma_addr_t ib;
		NNTI_gni_rdma_addr_t gni;
		NNTI_bgpdcmf_rdma_addr_t bgpdcmf;
		NNTI_bgqpami_rdma_addr_t bgqpami;
		NNTI_mpi_rdma_addr_t mpi;
		NNTI_local_rdma_addr_t local;
	} NNTI_remote_addr_t_u;
};
typedef struct NNTI_remote_addr_t NNTI_remote_addr_t;

typedef struct {
	u_int NNTI_remote_addr_array_t_len;
	NNTI_remote_addr_t *NNTI_remote_addr_array_t_val;
} NNTI_remote_addr_array_t;

enum NNTI_buf_ops_t {
	NNTI_PUT_SRC = 1,
	NNTI_PUT_DST = 2,
	NNTI_GET_SRC = 4,
	NNTI_GET_DST = 8,
	NNTI_SEND_SRC = 16,
	NNTI_RECV_DST = 32,
	NNTI_RECV_QUEUE = 64,
	NNTI_ATOMICS = 128
};
typedef enum NNTI_buf_ops_t NNTI_buf_ops_t;

struct NNTI_buffer_t {
	NNTI_datatype_t datatype;
	NNTI_transport_id_t transport_id;
	NNTI_peer_t buffer_owner;
	NNTI_remote_addr_array_t buffer_segments;
	NNTI_buf_ops_t ops;
	uint64_t payload_size;
	uint64_t payload;
	uint64_t transport_private;
};
typedef struct NNTI_buffer_t NNTI_buffer_t;

struct NNTI_work_request_t {
	NNTI_datatype_t datatype;
	NNTI_transport_id_t transport_id;
	NNTI_buffer_t *reg_buf;
	NNTI_buf_ops_t ops;
	NNTI_result_t result;
	uint64_t transport_private;
};
typedef struct NNTI_work_request_t NNTI_work_request_t;

struct NNTI_transport_header_t {
	uint32_t message_magic;
	uint32_t exchange_id;
};
typedef struct NNTI_transport_header_t NNTI_transport_header_t;

struct NNTI_status_t {
	NNTI_datatype_t datatype;
	NNTI_buf_ops_t op;
	NNTI_result_t result;
	uint64_t start;
	uint64_t offset;
	uint64_t length;
	NNTI_peer_t src;
	NNTI_peer_t dest;
};
typedef struct NNTI_status_t NNTI_status_t;

struct NNTI_transport_t {
	NNTI_datatype_t datatype;
	NNTI_transport_id_t id;
	NNTI_peer_t me;
};
typedef struct NNTI_transport_t NNTI_transport_t;

/* the xdr functions */

#if defined(__STDC__) || defined(__cplusplus)
extern  bool_t xdr_NNTI_size (XDR *, NNTI_size*);
extern  bool_t xdr_NNTI_ssize (XDR *, NNTI_ssize*);
extern  bool_t xdr_NNTI_datatype_t (XDR *, NNTI_datatype_t*);
extern  bool_t xdr_NNTI_transport_id_t (XDR *, NNTI_transport_id_t*);
extern  bool_t xdr_NNTI_result_t (XDR *, NNTI_result_t*);
extern  bool_t xdr_NNTI_atomic_op_t (XDR *, NNTI_atomic_op_t*);
extern  bool_t xdr_NNTI_ip_addr (XDR *, NNTI_ip_addr*);
extern  bool_t xdr_NNTI_tcp_port (XDR *, NNTI_tcp_port*);
extern  bool_t xdr_NNTI_null_process_t (XDR *, NNTI_null_process_t*);
extern  bool_t xdr_NNTI_nid (XDR *, NNTI_nid*);
extern  bool_t xdr_NNTI_pid (XDR *, NNTI_pid*);
extern  bool_t xdr_NNTI_portals_process_t (XDR *, NNTI_portals_process_t*);
extern  bool_t xdr_NNTI_qp_num (XDR *, NNTI_qp_num*);
extern  bool_t xdr_NNTI_ib_process_t (XDR *, NNTI_ib_process_t*);
extern  bool_t xdr_NNTI_instance_id (XDR *, NNTI_instance_id*);
extern  bool_t xdr_NNTI_gni_process_t (XDR *, NNTI_gni_process_t*);
extern  bool_t xdr_NNTI_bgpdcmf_process_t (XDR *, NNTI_bgpdcmf_process_t*);
extern  bool_t xdr_NNTI_bgqpami_process_t (XDR *, NNTI_bgqpami_process_t*);
extern  bool_t xdr_NNTI_mpi_process_t (XDR *, NNTI_mpi_process_t*);
extern  bool_t xdr_NNTI_local_process_t (XDR *, NNTI_local_process_t*);
extern  bool_t xdr_NNTI_remote_process_t (XDR *, NNTI_remote_process_t*);
extern  bool_t xdr_NNTI_peer_t (XDR *, NNTI_peer_t*);
extern  bool_t xdr_NNTI_null_rdma_addr_t (XDR *, NNTI_null_rdma_addr_t*);
extern  bool_t xdr_NNTI_match_bits (XDR *, NNTI_match_bits*);
extern  bool_t xdr_NNTI_portals_indices (XDR *, NNTI_portals_indices*);
extern  bool_t xdr_NNTI_portals_rdma_addr_t (XDR *, NNTI_portals_rdma_addr_t*);
extern  bool_t xdr_NNTI_ib_rdma_addr_t (XDR *, NNTI_ib_rdma_addr_t*);
extern  bool_t xdr_NNTI_gni_buffer_type_t (XDR *, NNTI_gni_buffer_type_t*);
extern  bool_t xdr_NNTI_gni_mem_hdl_t (XDR *, NNTI_gni_mem_hdl_t*);
extern  bool_t xdr_NNTI_gni_rdma_addr_t (XDR *, NNTI_gni_rdma_addr_t*);
extern  bool_t xdr_NNTI_bgpdcmf_memreg_hdl_t (XDR *, NNTI_bgpdcmf_memreg_hdl_t*);
extern  bool_t xdr_NNTI_bgpdcmf_buffer_type_t (XDR *, NNTI_bgpdcmf_buffer_type_t*);
extern  bool_t xdr_NNTI_bgpdcmf_rdma_addr_t (XDR *, NNTI_bgpdcmf_rdma_addr_t*);
extern  bool_t xdr_NNTI_bgqpami_buffer_type_t (XDR *, NNTI_bgqpami_buffer_type_t*);
extern  bool_t xdr_NNTI_bgqpami_rdma_addr_t (XDR *, NNTI_bgqpami_rdma_addr_t*);
extern  bool_t xdr_NNTI_mpi_rdma_addr_t (XDR *, NNTI_mpi_rdma_addr_t*);
extern  bool_t xdr_NNTI_local_rdma_addr_t (XDR *, NNTI_local_rdma_addr_t*);
extern  bool_t xdr_NNTI_remote_addr_t (XDR *, NNTI_remote_addr_t*);
extern  bool_t xdr_NNTI_remote_addr_array_t (XDR *, NNTI_remote_addr_array_t*);
extern  bool_t xdr_NNTI_buf_ops_t (XDR *, NNTI_buf_ops_t*);
extern  bool_t xdr_NNTI_buffer_t (XDR *, NNTI_buffer_t*);
extern  bool_t xdr_NNTI_work_request_t (XDR *, NNTI_work_request_t*);
extern  bool_t xdr_NNTI_transport_header_t (XDR *, NNTI_transport_header_t*);
extern  bool_t xdr_NNTI_status_t (XDR *, NNTI_status_t*);
extern  bool_t xdr_NNTI_transport_t (XDR *, NNTI_transport_t*);

#else /* K&R C */
extern bool_t xdr_NNTI_size ();
extern bool_t xdr_NNTI_ssize ();
extern bool_t xdr_NNTI_datatype_t ();
extern bool_t xdr_NNTI_transport_id_t ();
extern bool_t xdr_NNTI_result_t ();
extern bool_t xdr_NNTI_atomic_op_t ();
extern bool_t xdr_NNTI_ip_addr ();
extern bool_t xdr_NNTI_tcp_port ();
extern bool_t xdr_NNTI_null_process_t ();
extern bool_t xdr_NNTI_nid ();
extern bool_t xdr_NNTI_pid ();
extern bool_t xdr_NNTI_portals_process_t ();
extern bool_t xdr_NNTI_qp_num ();
extern bool_t xdr_NNTI_ib_process_t ();
extern bool_t xdr_NNTI_instance_id ();
extern bool_t xdr_NNTI_gni_process_t ();
extern bool_t xdr_NNTI_bgpdcmf_process_t ();
extern bool_t xdr_NNTI_bgqpami_process_t ();
extern bool_t xdr_NNTI_mpi_process_t ();
extern bool_t xdr_NNTI_local_process_t ();
extern bool_t xdr_NNTI_remote_process_t ();
extern bool_t xdr_NNTI_peer_t ();
extern bool_t xdr_NNTI_null_rdma_addr_t ();
extern bool_t xdr_NNTI_match_bits ();
extern bool_t xdr_NNTI_portals_indices ();
extern bool_t xdr_NNTI_portals_rdma_addr_t ();
extern bool_t xdr_NNTI_ib_rdma_addr_t ();
extern bool_t xdr_NNTI_gni_buffer_type_t ();
extern bool_t xdr_NNTI_gni_mem_hdl_t ();
extern bool_t xdr_NNTI_gni_rdma_addr_t ();
extern bool_t xdr_NNTI_bgpdcmf_memreg_hdl_t ();
extern bool_t xdr_NNTI_bgpdcmf_buffer_type_t ();
extern bool_t xdr_NNTI_bgpdcmf_rdma_addr_t ();
extern bool_t xdr_NNTI_bgqpami_buffer_type_t ();
extern bool_t xdr_NNTI_bgqpami_rdma_addr_t ();
extern bool_t xdr_NNTI_mpi_rdma_addr_t ();
extern bool_t xdr_NNTI_local_rdma_addr_t ();
extern bool_t xdr_NNTI_remote_addr_t ();
extern bool_t xdr_NNTI_remote_addr_array_t ();
extern bool_t xdr_NNTI_buf_ops_t ();
extern bool_t xdr_NNTI_buffer_t ();
extern bool_t xdr_NNTI_work_request_t ();
extern bool_t xdr_NNTI_transport_header_t ();
extern bool_t xdr_NNTI_status_t ();
extern bool_t xdr_NNTI_transport_t ();

#endif /* K&R C */

#ifdef __cplusplus
}
#endif

#endif /* !_TRIOS_NNTI_XDR_H_RPCGEN */
